#include "tech-edit.h"
#include "utility.h"
#include "errtrap.h"
#include "tap.h"

extern int createMinRule();
extern int createMaxRule();
extern int showRule();
extern int deleteRule();
extern int setDevice();
/* extern int editLayer(); */
extern int finish();

RPCFunction CommandArray[] = {
    { createMinRule, 	"Tech Edit", 	"min-rule"},
    { createMaxRule, 	"Tech Edit", 	"max-rule"},
    { showRule, 	"Tech Edit", 	"show-rule"},
    { deleteRule, 	"Tech Edit", 	"delete-rule"},
    /* { setDevice, 	"Tech Edit", 	"display-device"}, */
    /* { editLayer, 	"Tech Edit", 	"layer-looks"}, */
    { finish, 		"Tech Edit", 	"quit-tech-edit"}
};

/*ARGSUSED*/
long UserMain(display, spotPtr, cmdList, userOptionWord, array)
char *display;
RPCSpot *spotPtr;
lsList cmdList;
long userOptionWord;
RPCFunction **array;
{
    octObject techProp;
    octObject bigBag, ruleBag;
    octGenerator gen;
    octStatus status;

    /*ERROR_SET();*/
    if (setjmp(errorEnvironment) != 0) {
	printError("Fatal error in tech-edit startup -- good-bye");
	RPCExit(-1);
    }

    displayName = display;
    if (XOpenDisplay(displayName) == NIL(Display)) {
	errRaise( "TECH-EDIT", 1, "Couldn't open display");
    }

    maxSelSet = vemNewSelSet(spotPtr->facet, MAX_RED, MAX_GRN, MAX_BLU,
			    1, 1, 1, 1, "0");
    minSelSet = vemNewSelSet(spotPtr->facet, MIN_RED, MIN_GRN, MIN_BLU,
			    1, 1, 1, 1, "0");

    theFacet.objectId = spotPtr->facet;
    OCT_ASSERT(octGetById(&theFacet));

    techProp.type = OCT_PROP;
    techProp.contents.prop.name = TECH_PROP_NAME;
    techProp.contents.prop.type = OCT_STRING;
    techProp.contents.prop.value.string = TAP_TECH_PROP_VAL;
    OCT_ASSERT(octGetOrCreate(&theFacet, &techProp));
    techPropOK = (techProp.contents.prop.type == OCT_STRING) &&
	(strcmp(techProp.contents.prop.value.string, TAP_TECH_PROP_VAL) == 0);

    bigBag.type = OCT_BAG;
    bigBag.contents.bag.name = BIG_BAG_NAME;
    OCT_ASSERT(octGetOrCreate(&theFacet, &bigBag));

    OCT_ASSERT(octInitGenContents(&bigBag, OCT_BAG_MASK, &gen));
    while ((status = octGenerate(&gen, &ruleBag)) == OCT_OK) {
	if (strcmp(ruleBag.contents.bag.name, MAX_NAME) == 0) {
	    VEM_ASSERT(vemAddSelSet(maxSelSet,
				ruleBag.objectId));	/* SUPPRESS 55 */
	} else if (strcmp(ruleBag.contents.bag.name, MIN_NAME) == 0) {
	    VEM_ASSERT(vemAddSelSet(minSelSet,
				ruleBag.objectId));	/* SUPPRESS 55 */
	}
    }
    OCT_ASSERT(status);

    /* initLooksEditor(); */

    ITALICS("\nTech Edit operational\n");
    vemPrompt();

    *array = CommandArray;
    return(sizeof(CommandArray) / sizeof(RPCFunction));
}
