#include "port.h"
#include "rpc.h"
#include "errtrap.h"

jmp_buf errorEnvironment;
#define ERROR_SET()	{ if (setjmp(errorEnvironment) != 0) {		\
					backout();			\
					return(RPC_OK); } }

#define OCT_ASSERT(val)	{ if ((val) < OCT_OK) ERROR(octErrorString()); }
#define LS_ASSERT(val)	{ if ((val) != LS_OK)				\
			    ERROR("\nInternal list package RPC error\n"); }
#define VEM_ASSERT(val)	{ if ((val) != VEM_OK)				\
			    ERROR("\nInternal VEM package RPC error\n"); }
#define XDM_ASSERT(val)	{ if ((val) != XDM_TRUE) ERROR(XDMError()); }
/* #define TAP_ASSERT(val)	{ if ((val) != OCT_OK) ERROR(tapErrorString()); } */

#define ERROR(msg)	{ printError(msg);				\
					longjmp(errorEnvironment, 1);	\
					/*NOTREACHED*/ }

#define USAGE(msg)	{ VEMMSG(msg); vemPrompt(); return(RPC_OK); }

#define MAX(x, y)	((x) > (y) ? (x) : (y))
#define MIN(x, y)	((x) < (y) ? (x) : (y))

#define ITALICS(str)	(VEMMSG("\0062"), VEMMSG(str), VEMMSG("\0060"))
#define BOLD(str)	(VEMMSG("\0061"), VEMMSG(str), VEMMSG("\0060"))

char *displayName;
octObject theFacet;

#define octInitGenContents	octInitGenContentsSpecial
#define octInitGenContainers	octInitGenContainersSpecial

#define TECH_PROP_NAME		"TECHNOLOGY"
int techPropOK;			/* TECHNOLOGY property has correct value */

/* do octBoxes b1 and b2 intersect or touch */
#define BOX_INTERSECT(b1, b2)	\
		(((b1).upperRight.x >= (b2).lowerLeft.x) && \
		 ((b2).upperRight.x >= (b1).lowerLeft.x) && \
		 ((b1).upperRight.y >= (b2).lowerLeft.y) && \
		 ((b2).upperRight.y >= (b1).lowerLeft.y))

/* is octBox b1 completely inside b2 */
#define BOX_INSIDE(b1, b2)	\
		(((b1).lowerLeft.x >= (b2).lowerLeft.x) && \
		 ((b1).lowerLeft.y >= (b2).lowerLeft.y) && \
		 ((b1).upperRight.x <= (b2).upperRight.x) && \
		 ((b1).upperRight.y <= (b2).upperRight.y))

/* fix lowerLeft and upperRight corners of octBox box */
#define BOX_NORM(box)		\
    {	register octCoord temp;						\
	temp = MAX((box).lowerLeft.x, (box).upperRight.x);		\
	(box).lowerLeft.x = MIN((box).lowerLeft.x, (box).upperRight.x);	\
	(box).upperRight.x = temp;					\
	temp = MAX((box).lowerLeft.y, (box).upperRight.y);		\
	(box).lowerLeft.y = MIN((box).lowerLeft.y, (box).upperRight.y);	\
	(box).upperRight.y = temp;					\
    }

    /* Design-Rule Editing Definitions */

#define BIG_BAG_NAME	"DESIGN-RULES"		/* bag holding all rules */
#define MIN_NAME	"MINIMUM"		/* bag name for minimum rule */
#define MAX_NAME	"MAXIMUM"		/* bag name for maximum rule */

#define MIN_RULE	0
#define MAX_RULE	1

vemSelSet maxSelSet, minSelSet;

/* color of max rules -- pink */
#define MAX_RED		((unsigned short) 65535)
#define MAX_GRN		((unsigned short) 21000)
#define MAX_BLU		((unsigned short) 30000)

/* color of min rules -- cyan */
#define MIN_RED		((unsigned short) 0)
#define MIN_GRN		((unsigned short) 41500)
#define MIN_BLU		((unsigned short) 65535)

/* XXX What a crock */
#define LAMBDA		20




    /* Layer Looks Editing Definitions */

#define SLIDE_WIDTH             100
#define SLIDE_HEIGHT            10

#define BIT_SIZE                10

#define PATCH_WIDTH             50
#define PATCH_HEIGHT            50

#define DISPLAY_BAG_NAME	"DISPLAY-LOOKS"
#define DEFAULT_COLOR_NAME      "GENERIC-COLOR"
#define DEFAULT_BW_NAME         "GENERIC-BW"
#define PRIORITY_NAME		"PRIORITY"
#define COLOR_NAME		"RGB-VALS"
#define FILL_PATTERN_NAME	"FILL-PATTERN"
#define BORDER_PATTERN_NAME	"BORDER-PATTERN"
