#include "port.h"
#include "oct.h"
#include "oh.h"
#include "tap.h"

listAllDisplayTypes(t,v)
    char *t;
    char *v;
{
    octObject tapFacet, layer, bag, displayLooksBag;
    octGenerator genLayer, genBag;


    tapOpenTechFacet(t, v, &tapFacet, "r");

    printf( "Listing layers and dispaly types in %s\n", ohFormatName(&tapFacet ));


    octInitGenContents( &tapFacet, OCT_LAYER_MASK, &genLayer );
    while ( octGenerate( &genLayer, &layer ) == OCT_OK ) {
	printf( "%s\n", layer.contents.layer.name );

	if ( ohGetByBagName( &layer, &displayLooksBag, "DISPLAY-LOOKS" ) != OCT_OK ) continue;
	
	OH_ASSERT(octInitGenContents( &displayLooksBag, OCT_BAG_MASK, &genBag ));
	while( octGenerate( &genBag, &bag ) == OCT_OK ) {
	    printf( "\t%s\n", bag.contents.bag.name );
	}
    }

}


deleteDispType( out_tech, out_view, name )
    char* out_tech;
    char* out_view;
    char* name;			/* Name of the display type to delete. */
{
    octObject tapFacet, layer, bag, displayLooksBag;
    octGenerator genLayer, genBag;
    int count = 0;		/* Count deletions */

    tapOpenTechFacet(out_tech, out_view, &tapFacet, "a");

    printf( "Opened in %s\n", ohFormatName(&tapFacet ));

    octInitGenContents( &tapFacet, OCT_LAYER_MASK, &genLayer );
    while ( octGenerate( &genLayer, &layer ) == OCT_OK ) {
	if ( ohGetByBagName( &layer, &displayLooksBag, "DISPLAY-LOOKS" ) != OCT_OK ) continue;
	
	if ( ohGetByBagName( &displayLooksBag, &bag, name ) == OCT_OK ) {
	    count++;
	    ohRecursiveDelete( &bag, OCT_BAG_MASK | OCT_PROP_MASK );
	}
    }
    
    printf( "Deleted %s from %d layers\n", name, count );
    if ( count ) {
	octCloseFacet( &tapFacet );
    }
}
